# Kapitel 12 - Lösungen

from math import *
from SWGui import *
initSWGui()

n=200
Zeichenfeld=SWCanvas(width=n,height=n)
bitmap=Zeichenfeld.createImage(0,0,(n,n))

# Aufgabe 1

def zeichneLinie(x1,y1,x2,y2):
    m=(y2-y1)/(x2-x1) # Steigung
    b=y1-m*x1 # Achsenabschnitt y-m*x=b
    if abs(m)<=1: # y-Bereich kleiner als x-Bereich
        for x in range(x1,x2):
            y=int(m*x+b)
            bitmap.setPixel(x,y,0) # Setze auf schwarz
    else:
        for y in range(y1,y2):
            x=int((y-b)/m)
            bitmap.setPixel(x,y,0) # Setze auf schwarz

zeichneLinie(10,10,20,100)

# Aufgabe 2

def Ellipse(xm,ym,ra,rb):
    for alpha in range(360):
        x=xm+ra*cos(alpha/180*pi)
        y=ym+rb*sin(alpha/180*pi)
        bitmap.setPixel(x,y,0)
Ellipse(30,50,10,20)

def Parabel():
    for x in range(n): bitmap.setPixel(x,x*x/100,100)
Parabel()


# Aufgabe 3 - Julia Menge

c=[0,0.5]
for ix in range(n):
    for iy in range(n):
        x=(ix-n/2)/50
        y=(iy-n/2)/50
        counter=50
        grenze=20
        while counter>0 and sqrt(x**2+y**2)<grenze:
            counter+=-1
            # (x+iy)=(x+iy)^2+c=x^2-y^2+2ixy+c
            [x,y]=[x**2-y**2+c[0],2*x*y+c[1]]
        if sqrt(x**2+y**2)<grenze:
            bitmap.setPixel(ix,iy,100)



