# Kapitel 3 - Lösungen

from math import *

def sumQuadrate(n):
    summe=0
    for i in range(n+1):
        summe=summe+i**2
    return summe

print("Quadratsumme 1^2+2^2+..+5^2=",sumQuadrate(5))

def FlaschenVolumen(radius,hoeheZyl,hoeheKegel):
    volZyl=pi*radius**2*hoeheZyl
    volKegel=pi*radius**2*hoeheKegel/3
    return volZyl+volKegel

print("Volumen einer Flasche mit Radis 4cm, Höhe 18cm, davon 10cm zylindrisch is ",
    FlaschenVolumen(4,10,8))

def piApprox(n): # n ist die Zahl der Streifen
    flaeche=0.0
    delta=2/float(n) # Streifenbreite
    for i in range(n):
        x=-1.0+i*delta
        y=sqrt(1.0-x**2)
        flaeche+=y*delta
    return 2*flaeche

print("pi ist ca. ",  piApprox(100000))


from SWGui import *

initSWGui()
Zeichenfeld=SWCanvas(width=400,height=400)
Zeichenfeld.showCoSys()

def nEck(r,n):
    deltaPhi=2*pi/n
    phi=0
    for i in range(n):
        x0=r*cos(phi)
        y0=r*sin(phi)
        x1=r*cos(phi+deltaPhi)
        y1=r*sin(phi+deltaPhi)
        Zeichenfeld.createLineW(x0,y0,x1,y1)
        phi+=deltaPhi

nEck(8,5)

def spirale(R,PHI):
    phi=0
    r=0
    n=100 # 100 Zwischenpunkte berechnen
    [x0,y0]=[0,0]
    for i in range(100):
        phi+=PHI/n
        r+=R/n
        [x1,y1]=[r*cos(phi),r*sin(phi)]
        stueck=Zeichenfeld.createLineW(x0,y0,x1,y1)
        if i%2==0: stueck.setColor("blue")
        else: stueck.setColor("green")
        [x0,y0]=[x1,y1]

spirale(10,8*pi)
