# Kapitel 5


from turtle import *
from math import *




# Aufgabe 1 - Verschiedene Grundfiguren

def parallelogram(a,b,alpha):
    for i in range(2):
        forward(a)
        left(alpha)
        forward(b)
        left(180-alpha)
def raute(a,alpha):
    parallelogram(a,a,alpha)
def drache(a,b,alpha): # Symmetrieachse AC, a=AB, b=BC, alpha ist Winkel bei A
    right(alpha/2)
    forward(a)
    s=a*sin(pi/180*alpha/2) # Halbe Länge der Diagonalen BD
    epsilon=180/pi*acos(s/b) # Winkel CBM im Dreieck BCM, M=Diagonalenschnitt
    left(180-(90-alpha/2)-epsilon)
    forward(b)
    left(2*epsilon)
    forward(b)
    left(180-(90-alpha/2)-epsilon)
    forward(a)
    left(180-alpha/2)


def trapez(a,beta,b,c):
    h=b*sin(beta/180*pi)
    a1=a-b*cos(beta/180*pi)-c # Abschnitt von a bis zur Projektion von C
    alpha=180/pi*atan(h/a1) 
    d=h/sin(alpha/180*pi)
    forward(a)
    left(180-beta)
    forward(b)
    left(beta)
    forward(c)
    left(alpha)
    forward(d)
    left(180-alpha)
    
penup()
goto(-300,0)
pendown()
parallelogram(100,50,45)

penup()
goto(0,0)
pendown()
raute(100,30)

penup()
goto(-300,200)
pendown()
trapez(100,30,50,20)

penup()
goto(0,200)
pendown()
trapez(100,110,50,200)

penup()
goto(200,200)
pendown()
drache(45,150,50)

# Aufgabe 2

def Kreisbogen(r,alpha):
    n=50 # aus 50 Stückchen zusammensetzen
    U=2*pi*r # Umfang des Kreises
    US=U*alpha/360 # Umfang des Segmentes = Anteil am Kreis
    for i in range(n):
        forward(US/n)
        left(alpha/n)

pencolor("blue")
penup()
goto(0,0)
pendown()
Kreisbogen(150,180)

# Aufgabe 3 : Funktionsplotter

def FunktPlot(f,xmax,PixelMax):
    # Zeichnet f für x=-xmax..xmax in den Pixelbereich -PixelMax..PixelMax
    penup()
    goto(-PixelMax,0)
    pendown()
    seth(0) # Blick nach rechts
    for x in range(-PixelMax,PixelMax):
        X=xmax*x/PixelMax
        Y=f(X)
        goto(int(X/xmax*PixelMax),int(Y/xmax*PixelMax))
        
pencolor("red")
FunktPlot(sin,6.29,300)

        
# Aufgabe 4

def SierpinsiDreieck(a,n): # a Laenge, n =Stufe
    if n==1:
        for i in range(3):
            forward(a)
            left(120)
    if n>1:
        SierpinsiDreieck(a/2,n-1)
        forward(a/2)
        SierpinsiDreieck(a/2,n-1)
        penup()
        backward(a/4)
        left(90)
        forward(a*sqrt(3)/4)
        right(90)
        pendown()
        SierpinsiDreieck(a/2,n-1)
        penup()
        backward(a/4)
        right(90)
        forward(a*sqrt(3)/4)
        left(90)
        pendown()
penup()
goto(-200,-150)
pendown()
SierpinsiDreieck(200,5)


        
