# Kapitel 11 - Lösungen

from math import *
from visual import *

# Aufgabe 1 - eine Pyramide
# Das Grundquadrat
cylinder(pos=(5,5,5),axis=(2,0,0),color=color.green, radius=0.1)
cylinder(pos=(7,5,5),axis=(0,0,2),color=color.green, radius=0.1)
cylinder(pos=(7,5,7),axis=(-2,0,0),color=color.green, radius=0.1)
cylinder(pos=(5,5,7),axis=(0,0,-2),color=color.green, radius=0.1)
# und die Spitze
cylinder(pos=(5,5,5),axis=(1,1,1),color=color.green, radius=0.1)
cylinder(pos=(7,5,5),axis=(-1,1,1),color=color.green, radius=0.1)
cylinder(pos=(7,5,7),axis=(-1,1,-1),color=color.green, radius=0.1)
cylinder(pos=(5,5,7),axis=(1,1,-1),color=color.green, radius=0.1)


# Aufgabe 2

# Gerade als Strecke von A nach B
A=vector(-7,2,-1)
B=vector(8,1,5)
gerade=cylinder(pos=A,axis=B-A,color=color.red, radius=0.2)
# Ein fester Punkt P 
P=sphere(pos=(1,8,1),radis=0.5,color=color.blue)

# Die Verbindungsstrecke und ein Punkt S, der auf der Geraden wandern wird
verbindung=cylinder(pos=A,axis=P.pos-A,color=color.green,radius=0.2)
S=sphere(pos=A,radis=0.2,color=color.white)
# Ein Label zum Anzeigen der Distanz
L=label(pos=(0,0.25,0),text="")
        
n=100
for i in range(n):
    rate(20)
    S.pos=A+(B-A)*i/float(n)
    verbindung.pos=S.pos
    verbindung.axis=P.pos-S.pos
    L.pos=(S.pos+P.pos)/2
    d=mag(S.pos-P.pos)
    d=int(100*d)/100.0
    L.text=str(d)
        
    
    

    

    


