# Kapitel 12 - Lösungen

from math import *
import cmath
from SWGui import *
initSWGui()

rahmen=SWFrameVert()
Zeichenfeld1=SWCanvas(container=rahmen) 
text=SWText(container=rahmen, width=60)
Zeichenfeld2=SWCanvas(container=rahmen) 
Zeichenfeld3=SWCanvas(container=rahmen) 
Zeichenfeld4=SWCanvas(container=rahmen) 
bitmap1=Zeichenfeld1.createImage(0,0,"testbild.gif")
bitmap2= Zeichenfeld2.createImage(0,0, (bitmap1.getWidth(), bitmap1.getHeight()))
bitmap3= Zeichenfeld3.createImage(0,0, (bitmap1.getWidth(), bitmap1.getHeight()))
bitmap4= Zeichenfeld4.createImage(0,0, (bitmap1.getWidth(), bitmap1.getHeight()))

# Aufgabe 4

Summe=0
for ix in range(bitmap2.getWidth()):
    for iy in range(bitmap2.getHeight()):
        Summe+=bitmap1.getPixel(ix,iy)
Mittelwert=Summe/(bitmap2.getWidth()*bitmap2.getHeight())
text.addText("Mittelwert="+str(Mittelwert))
Summe=0
for ix in range(bitmap2.getWidth()):
    for iy in range(bitmap2.getHeight()):
        Summe+=(bitmap1.getPixel(ix,iy)-Mittelwert)**2
Standardab=sqrt(Summe/(bitmap2.getWidth()*bitmap2.getHeight()))
text.addText("\nStandardab="+str(Standardab))

for ix in range(bitmap2.getWidth()):
    for iy in range(bitmap2.getHeight()):
        w=bitmap1.getPixel(ix,iy)
        # Jetzt w in Richtung uf Mittelwert verändern
        w=Mittelwert+(w-Mittelwert)/2
        bitmap2.setPixel(ix,iy,w,False)
bitmap2.flush()

# Aufgabe 5 - eine kleine Rotation als Beispiel 
alpha=30/180.0*pi
for ix in range(bitmap1.getWidth()):
    for iy in range(bitmap1.getHeight()):
        rgb=bitmap1.getPixelRGB(ix,iy)
        x=cos(alpha)*ix+sin(alpha)*iy
        y=-sin(alpha)*ix+cos(alpha)*iy
        bitmap3.setPixelRGB(x,y,rgb,False)
bitmap3.flush()

# Aufgabe 6 - das Wurzel als Beispiel 
alpha=30/180.0*pi
for ix in range(bitmap1.getWidth()):
    for iy in range(bitmap1.getHeight()):
        rgb=bitmap1.getPixelRGB(ix,iy)
        x=5.0*(ix-bitmap1.getWidth()/2)/float(bitmap1.getWidth())
        y=5.0*(bitmap1.getHeight()/2-iy)/float(bitmap1.getHeight())
        z=complex(x,y)
        #Z=cmath.sqrt(z)
        Z=z**2
        X=(Z.real+5.0)/10.0*bitmap1.getWidth()
        Y=(-Z.imag+5.0)/10.0*bitmap1.getHeight()
        bitmap4.setPixelRGB(X,Y,rgb,False)
bitmap4.flush()

