# Aufgabe 1

def mysum(L):
    summe=0
    for x in L: summe+=x
    return summe
def mymax(L):
    M=-1e100
    for x in L:
        if x>M: M=x
    return M
def mymin(L):
    M=1e100
    for x in L:
        if x<M: M=x
    return M

print("mymax([7,4,9,6])=", mymax([7,4,9,6]))
print()

# Aufgabe 2
punkte=[12,45,32,44,39,38,39,41,7,22,29,35,11,12,46,33,28,29,17,21,12,23,30,25,31,15,39]

print("Es gibt ", len(punkte), "Schüler")
print("Minimum=",min(punkte),"Minimum=",max(punkte))
print("Mittelwert=",sum(punkte)/len(punkte))

for p in range(50): print(punkte.count(p)," Schüler haben ",p, " Punkte")

print()
n30er=0
for p in range(30,40): n30er=n30er+punkte.count(p)
print(n30er," Schüler haben eine Punktsumme >=30 und <40")


print()
P3A=[p+3 for p in punkte]

P3B=[]
for p in punkte: P3B.append(p+3)

P3C=[]
for p in punkte: P3C=P3C+[p+3]

P3D=[]
for i in range(len(punkte)): P3D=P3D+[punkte[i]+3]

print("Die um drei Punkte erhöhte Liste ist....")
print(P3A)
print(P3B)
print(P3C)
print(P3D)


# Funktionen aus dem Skript
import math
def mittelwert(liste):
    return sum(liste)/len(liste)

def varianz(liste):
    m=mittelwert(liste)
    return mittelwert([(x-m)**2 for x in liste])

def genormt(liste): # Gibt eine Liste mit Mittel 0, Standardabw. 1
    m=mittelwert(liste)
    s=math.sqrt(varianz(liste)) # Standardabweichung
    return [ (x-m)/s for x in liste ]

def korrel(A,B):
    if len(A)!=len(B):
        print("Fehler in korrel: Ungleiche Längen")
        return 
    An=genormt(A)
    Bn=genormt(B)
    r=0.0
    for i in range(0,len(A)): r+=An[i]*Bn[i]
    return r/len(A)

print("Korrelation zwischen Punkten und korrigierten Punkten: ",korrel(punkte,P3A))
print()

# Aufgabe 3 : Korrelation von Werten und Funktionswerten
X=[x for x in range(-10,11)]
Y=[x**2 for x in X]
print("Korrelation bei der Parabel auf -10..10: ",korrel(X,Y))
Y=[x**3 for x in X]
print("Korrelation bei der kubischen Parabel auf -10..10: ",korrel(X,Y))
X=[x for x in range(0,11)]
Y=[x**2 for x in X]
print("Korrelation bei der Parabel auf 0..10: ",korrel(X,Y))



#  Aufgabe 4 Zentraler Grenzwertsatz
from random import *
def Z(): return randrange(-1,2)

print("20 mal die Zufallsvariable Z: ",[Z() for i in range(20)])
print("Erwartungswert ist ca. ",mittelwert([Z() for i in range(100000)]))
print("Theoretisch: E(Z)=-1*1/3+0*1/3+1*1/3=0")
print("Standardabw ist ca. ",math.sqrt(varianz([Z() for i in range(100000)])))
S=math.sqrt(1/3*(-1)**2+1/3*0+1/3*1**2)
print("Theoretisch Standardabweichung=sqrt(1/3*(-1)^2+1/3*0+1/3*1^2)=",S)

def SNV():
    n=10000
    L=[Z() for i in range(n)]
    return sum(L)/(math.sqrt(n)*S)

ZL=[SNV() for i in range(1000)]

print("Starte Erzeugung von 1000 normalverteilten Zufallsvariablen SNV.")
print("Mittelwert von SNV =",mittelwert(ZL))
print("Standardabweichung von SNV =",math.sqrt(varianz(ZL)))


# Aufgabe 5 Nichtparametrische Tests

print()
print("Nichtparametrischer Hypothesentest")
S1=[44.6,55.0,52.5 , 50.2 ,45.2, 46.0, 52.0, 50.2, 50.7,49.2,47.3,50.1,
    51.6, 48.7, 54.2, 46.1, 49.9, 52.3, 48.7, 56.9]
S2=[44.7,  54.8, 55.6, 55.2, 45.6, 47.7, 53.0, 49.9, 52.2, 50.6,46.1, 
    52.3,53.9,47.1,57.2,52.7,49.0,54.9,51.4,56.1] 

differenzen=[S1[i]-S2[i] for i in range(len(S1))]
diffSumme=sum(differenzen)

def PM(): # Ergibt +1 oder -1 mit Wahrscheinlichkeit 50%
    if randrange(0,2)==1: return 1
    else: return -1

def ListeMitZufaelligenVorzeichen(L):
    return [PM()*abs(x) for x in L]

n=50000 # 50000 Runden der Simulation
excounter=0 # Zählt, wie oft der simulierte Wert kleiner als der beobachtete ist

for i in range(n):
    if sum(ListeMitZufaelligenVorzeichen(differenzen))<diffSumme: excounter+=1

print("Wahrscheinlickeit für eine so extreme Differenz ist nur ",excounter/n)








