# Kapitel 6 - Lösungen

# Aufgabe 1 - Summe der Teiler

# 1. Weg - Nutzung der im Kapitel erarbeiteten Funktionen
def teilt(teiler,n): return n%teiler==0 
def teiler(n): return [t for t in range(1,n+1) if teilt(t,n)]

def tau(n): return sum(teiler(n))

# 2. Weg: Von grund auf programmieren:

def tau2(n):
    summe=0
    for t in range(1,n+1):
        if n%t==0: summe=summe+t
    return summe

for i in range(10,20):
    print("tau(",i,")=",tau(i),"=",tau2(i))

def perfekteZahl(n): return 2*n==tau(n)

for i in range(1,1000):
    if perfekteZahl(i): print(i," ist perfekt")
print()


# Aufgabe 2

def ggT(a,b): # Rekursive Definition nach Euklid
    if b==0: return a
    return ggT(b,a%b)

# Aufgabe 3

def P3(n): return 3==len(teiler(n))
def P4(n): return 4==len(teiler(n))

for i in range(1,100):
    if P3(i): print(i," ist eine Dreiteilerzahl")
print()
for i in range(1,100):
    if P4(i): print(i," ist eine Vierteilerzahl")
print()
    

# Aufgabe 4

def istQuadratischerRest(a,n):
    for x in range(0,n):
        if (x*x-a)%n==0: return x
    return -1

print("Die quadratischen Reste mod 11 sind:")
for z in range(1,11):
    if istQuadratischerRest(z,11)>=0:
        print(z," ist qudratischer Rest, denn ",istQuadratischerRest(z,11),"^2=",z," mod 11")




