# Kapitel 7 - Lösungen

from math import *

# Aufgabe 1 

def mytan(x):
    if abs(x)<1e-8: return x # Denn tan(x) ist ca x für kleine x
    t=mytan(x/2)
    return 2*t/(1-t**2)
for x in range(1,10):
    print("x= ",x," tan=",tan(x)," mytan=",mytan(x)," Differenz=",tan(x)-mytan(x))


# Aufgabe 2

def mylog(x):
    if abs(x-1)<1e-8: return x-1
    if x<1: return -mylog(1/x)
    w=sqrt(x) #  also x=w^2, ln(x)=2*ln(w)
    return 2*mylog(w)

print()
for x in range(1,10):
    print("x= ",x," log=",log(x)," mylog=",mylog(x)," Differenz=",log(x)-mylog(x))



# Aufgabe 3

def myasin(x): # Benutzt sin als Blackbox
    if x>1 or x<-1:
        print("Unuzulässiges Argument für myasin x=",x)
        return None
    if x<0: return -myasin(-x) # Symmetrie ausnutzen
    if x<1e-10: return x # Lineare Appoximation ist gut
    y=pi/4 # Gesucht wird y, so dass x=sin(y)
    while abs(sin(y)-x)>1e-10: # y noch nicht gefunden
        y=y-(sin(y)-x) # Verbesserung
    return y
    
print()    
for i in range(-10,10):
    x=i/10
    print("x= ",x," asin=",asin(x)," myasin=",myasin(x),
          " Differenz=",asin(x)-myasin(x))
    
